diff --git a/include/signal.h b/include/signal.h
index 2a278697c1..73f18dddd7 100644
--- a/include/signal.h
+++ b/include/signal.h
@@ -14,10 +14,8 @@ libc_hidden_proto (__sigpause)
 libc_hidden_proto (raise)
 libc_hidden_proto (__libc_current_sigrtmin)
 libc_hidden_proto (__libc_current_sigrtmax)
-extern const char * const __sys_siglist[_NSIG];
-libc_hidden_proto (__sys_siglist)
-extern const char * const __sys_sigabbrev[_NSIG];
-libc_hidden_proto (__sys_sigabbrev)
+extern const char * const __sys_siglist[_NSIG] attribute_hidden;
+extern const char * const __sys_sigabbrev[_NSIG] attribute_hidden;
 
 /* Now define the internal interfaces.  */
 extern __sighandler_t __bsd_signal (int __sig, __sighandler_t __handler);
diff --git a/stdio-common/Makefile b/stdio-common/Makefile
index 087acb82b6..98872d9f88 100644
--- a/stdio-common/Makefile
+++ b/stdio-common/Makefile
@@ -215,6 +215,8 @@ tests := \
 generated += \
   errlist-data-aux.os \
   errlist-data-aux.o \
+  siglist-aux.os \
+  siglist-aux.o \
   # generated
 
 test-srcs = tst-unbputc tst-printf tst-printfsz-islongdouble
@@ -262,6 +264,17 @@ $(objpfx)errlist-data-aux.o: errlist-data-gen.c
 $(objpfx)errlist-data.os: $(objpfx)errlist-data-aux.os
 $(objpfx)errlist-data.o: $(objpfx)errlist-data-aux.o
 
+$(objpfx)siglist-aux.os: siglist-gen.c
+	$(make-target-directory)
+	$(compile-command.c) $(no-stack-protector) -S
+
+$(objpfx)siglist-aux.o: siglist-gen.c
+	$(make-target-directory)
+	$(compile-command.c) $(no-stack-protector) -S
+
+$(objpfx)siglist.os: $(objpfx)siglist-aux.os
+$(objpfx)siglist.o: $(objpfx)siglist-aux.o
+
 ifeq ($(run-built-tests),yes)
 LOCALES := \
   de_DE.ISO-8859-1 \
@@ -350,7 +363,6 @@ CFLAGS-isoc99_vfscanf.c += -fexceptions
 CFLAGS-isoc99_vscanf.c += -fexceptions
 CFLAGS-isoc99_fscanf.c += -fexceptions
 CFLAGS-isoc99_scanf.c += -fexceptions
-CFLAGS-siglist.c += $(fno-unit-at-a-time)
 
 # scanf14a.c and scanf16a.c test a deprecated extension which is no
 # longer visible under most conformance levels; see the source files
diff --git a/stdio-common/siglist.c b/stdio-common/siglist-gen.c
similarity index 92%
rename from stdio-common/siglist.c
rename to stdio-common/siglist-gen.c
index bb88d5300f..95441b707d 100644
--- a/stdio-common/siglist.c
+++ b/stdio-common/siglist-gen.c
@@ -26,7 +26,6 @@ const char *const __sys_siglist[NSIG] =
 #include <siglist.h>
 #undef init_sig
 };
-libc_hidden_def (__sys_siglist)
 
 const char *const __sys_sigabbrev[NSIG] =
 {
@@ -34,6 +33,3 @@ const char *const __sys_sigabbrev[NSIG] =
 #include <siglist.h>
 #undef init_sig
 };
-libc_hidden_def (__sys_sigabbrev)
-
-#include <siglist-compat.c>
diff --git a/stdio-common/siglist.S b/stdio-common/siglist.S
new file mode 100644
index 0000000000..327f105e6f
--- /dev/null
+++ b/stdio-common/siglist.S
@@ -0,0 +1,7 @@
+#ifdef SHARED
+# include "siglist-aux.os"
+#else
+# include "siglist-aux.o"
+#endif
+
+#include <siglist-compat.h>
diff --git a/sysdeps/generic/siglist-compat.h b/sysdeps/generic/siglist-compat-def.h
similarity index 69%
rename from sysdeps/generic/siglist-compat.h
rename to sysdeps/generic/siglist-compat-def.h
index 05a0d63855..f5a1840dc3 100644
--- a/sysdeps/generic/siglist-compat.h
+++ b/sysdeps/generic/siglist-compat-def.h
@@ -28,20 +28,23 @@
    sys_sigabbrev alias to __sys_sigabbrev.  Both target alias are
    define in siglist.c.  */
 #define DEFINE_COMPAT_SIGLIST(NUMBERSIG, VERSION) 			     \
-  declare_symbol_alias (__ ## VERSION ## _sys_siglist,			     \
-			__sys_siglist,					     \
-			object,	NUMBERSIG * (ULONG_WIDTH / UCHAR_WIDTH));    \
-  declare_symbol_alias (__ ## VERSION ## sys_siglist,			     \
-			__sys_siglist,					     \
-			object,	NUMBERSIG * (ULONG_WIDTH / UCHAR_WIDTH));    \
-  declare_symbol_alias (__ ## VERSION ## _sys_sigabbrev,		     \
-			__sys_sigabbrev,				     \
-			object, NUMBERSIG * (ULONG_WIDTH / UCHAR_WIDTH));    \
+  declare_object_symbol_alias (__ ## VERSION ## _sys_siglist,		     \
+			       __sys_siglist,				     \
+			       NUMBERSIG * (ULONG_WIDTH / UCHAR_WIDTH))      \
+			       ASM_LINE_SEP				     \
+  declare_object_symbol_alias (__ ## VERSION ## sys_siglist,		     \
+			       __sys_siglist,				     \
+			       NUMBERSIG * (ULONG_WIDTH / UCHAR_WIDTH))      \
+			       ASM_LINE_SEP				     \
+  declare_object_symbol_alias (__ ## VERSION ## _sys_sigabbrev,		     \
+			       __sys_sigabbrev,				     \
+			       NUMBERSIG * (ULONG_WIDTH / UCHAR_WIDTH))      \
+			       ASM_LINE_SEP				     \
   compat_symbol (libc, __## VERSION ## _sys_siglist,   _sys_siglist,	     \
-		 VERSION);						     \
+		 VERSION) ASM_LINE_SEP					     \
   compat_symbol (libc, __## VERSION ## sys_siglist,    sys_siglist,	     \
-		 VERSION);						     \
+		 VERSION) ASM_LINE_SEP					     \
   compat_symbol (libc, __## VERSION ## _sys_sigabbrev, sys_sigabbrev,	     \
-		 VERSION);						     \
+		 VERSION)
 
 #endif
diff --git a/sysdeps/generic/siglist-compat.c b/sysdeps/generic/siglist-compat.c
deleted file mode 100644
index 6e25b021ab..0000000000
--- a/sysdeps/generic/siglist-compat.c
+++ /dev/null
@@ -1 +0,0 @@
-/* Empty.  */
diff --git a/sysdeps/mach/hurd/siglist-compat.c b/sysdeps/mach/hurd/siglist-compat.h
similarity index 86%
rename from sysdeps/mach/hurd/siglist-compat.c
rename to sysdeps/mach/hurd/siglist-compat.h
index 5334b0885b..17bb0401aa 100644
--- a/sysdeps/mach/hurd/siglist-compat.c
+++ b/sysdeps/mach/hurd/siglist-compat.h
@@ -16,12 +16,15 @@
    License along with the GNU C Library; if not, see
    <https://www.gnu.org/licenses/>.  */
 
-#include <siglist-compat.h>
+#include <siglist-compat-def.h>
+/* To get _NSIG definition.  */
+#define _SIGNAL_H
+#include <bits/signum-generic.h>
 
 #if SHLIB_COMPAT (libc, GLIBC_2_0, GLIBC_2_1)
 DEFINE_COMPAT_SIGLIST (33, GLIBC_2_0)
 #endif
 
 #if SHLIB_COMPAT (libc, GLIBC_2_1, GLIBC_2_32)
-DEFINE_COMPAT_SIGLIST (NSIG, GLIBC_2_1)
+DEFINE_COMPAT_SIGLIST (_NSIG, GLIBC_2_1)
 #endif
diff --git a/sysdeps/unix/sysv/linux/siglist-compat.c b/sysdeps/unix/sysv/linux/siglist-compat.h
similarity index 87%
rename from sysdeps/unix/sysv/linux/siglist-compat.c
rename to sysdeps/unix/sysv/linux/siglist-compat.h
index cbc77289c0..2a9801276d 100644
--- a/sysdeps/unix/sysv/linux/siglist-compat.c
+++ b/sysdeps/unix/sysv/linux/siglist-compat.h
@@ -16,7 +16,10 @@
    License along with the GNU C Library; if not, see
    <https://www.gnu.org/licenses/>.  */
 
-#include <siglist-compat.h>
+#include <siglist-compat-def.h>
+/* To get _NSIG definition.  */
+#define _SIGNAL_H
+#include <bits/signum-generic.h>
 
 #if SHLIB_COMPAT (libc, GLIBC_2_0, GLIBC_2_1)
 DEFINE_COMPAT_SIGLIST (32, GLIBC_2_0)
@@ -27,5 +30,5 @@ DEFINE_COMPAT_SIGLIST (64, GLIBC_2_1)
 #endif
 
 #if SHLIB_COMPAT (libc, GLIBC_2_3_3, GLIBC_2_32)
-DEFINE_COMPAT_SIGLIST (NSIG, GLIBC_2_3_3)
+DEFINE_COMPAT_SIGLIST (_NSIG, GLIBC_2_3_3)
 #endif