diff --git a/include/printf.h b/include/printf.h
index 78accaab6d..8f064149d3 100644
--- a/include/printf.h
+++ b/include/printf.h
@@ -41,6 +41,16 @@ union printf_arg
     void *pa_user;
 };
 
+/* Invoke a registered printf callback.  Called from vfprintf and vfwprintf.  */
+int __printf_function_invoke (void *, printf_function callback,
+			      union printf_arg *args_value,
+			      size_t ndata_args,
+			      struct printf_info *info) attribute_hidden;
+int __wprintf_function_invoke (void *, printf_function callback,
+			       union printf_arg *args_value,
+			       size_t ndata_args,
+			       struct printf_info *info) attribute_hidden;
+
 #include <bits/types/locale_t.h>
 
 /* Now define the internal interfaces.  */
diff --git a/stdio-common/Makefile b/stdio-common/Makefile
index 5ba381fe41..9195b209cd 100644
--- a/stdio-common/Makefile
+++ b/stdio-common/Makefile
@@ -63,6 +63,7 @@ routines := \
   printf_buffer_write \
   printf_fp \
   printf_fphex \
+  printf_function_invoke \
   printf_size \
   psiginfo \
   psignal \
@@ -101,6 +102,7 @@ routines := \
   wprintf_buffer_puts_1 \
   wprintf_buffer_to_file \
   wprintf_buffer_write \
+  wprintf_function_invoke \
   # routines
 
 aux := \
diff --git a/stdio-common/Xprintf_function_invoke.c b/stdio-common/Xprintf_function_invoke.c
new file mode 100644
index 0000000000..f631469ba9
--- /dev/null
+++ b/stdio-common/Xprintf_function_invoke.c
@@ -0,0 +1,42 @@
+/* Invoke a printf specifier handler.  Generic version.
+   Copyright (C) 1991-2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+int
+Xprintf (function_invoke) (void *buf,
+                           printf_function callback,
+                           union printf_arg *args_value,
+                           size_t ndata_args,
+                           struct printf_info *info)
+{
+  const void *args[ndata_args];
+  for (unsigned int i = 0; i < ndata_args; ++i)
+    args[i] = &args_value[i];
+
+  struct Xprintf (buffer_as_file) s;
+  Xprintf (buffer_as_file_init) (&s, buf);
+
+  /* Call the function.  */
+  int done = callback (Xprintf (buffer_as_file_get) (&s), info, args);
+
+  if (!Xprintf (buffer_as_file_terminate) (&s))
+    /* Low-level error.  */
+    return -1;
+
+  /* Potential error from the callback function.  */
+  return done;
+}
diff --git a/stdio-common/printf_function_invoke.c b/stdio-common/printf_function_invoke.c
new file mode 100644
index 0000000000..8919b892ca
--- /dev/null
+++ b/stdio-common/printf_function_invoke.c
@@ -0,0 +1,22 @@
+/* Invoke a printf specifier handler.  Multibyte version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <printf.h>
+#include <printf_buffer_as_file.h>
+#include "printf_buffer-char.h"
+#include "Xprintf_function_invoke.c"
diff --git a/stdio-common/wprintf_function_invoke.c b/stdio-common/wprintf_function_invoke.c
new file mode 100644
index 0000000000..29a6b4e073
--- /dev/null
+++ b/stdio-common/wprintf_function_invoke.c
@@ -0,0 +1,22 @@
+/* Invoke a printf specifier handler.  Wide version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <printf.h>
+#include <printf_buffer_as_file.h>
+#include "printf_buffer-wchar_t.h"
+#include "Xprintf_function_invoke.c"